CON
    buffSize = 400
    'timeOut  = (buffSize * 80_000_000) / 1000 
    timeOut  = 1500 
     
VAR
    long parameter1   
    long parameter2  
    long parameter3  
    long parameter4
    long parameter5
    
    ' Header data structure for kernel loader
    
    byte type               ' Type of file   
    byte destLSB            ' Destination start address LSB 
    byte destMSB            ' Destination start address MSB 
    byte destEndLSB         ' Destination end address LSB 
    byte destEndMSB         ' Destination end address MSB
    byte filename[16]       ' Will be filled with the filename
    long fileLength

    long currentBuffer
    byte buffer[buffSize]
    long bufferPointer
    long midBufferPointer
    long refTime
    long timer
    
OBJ
    tap    : "TAPloader.spin"
    kernel : "KernelLoader.spin"
    
PUB StartTapTransfer( fileType ) : Success
    Success := tap.start( @parameter1 )
 
PUB StartKernelTransfer( fname, fLength ) : Success | temp

    type        := 1                               ' 1 =  Basic program            (should always be 1)
    destLSB     := 1                               ' Destination start address LSB (should always be 1)
    destMSB     := 8                               ' Destination start address MSB (should always be 8)
    temp        := fLength + 2049                  ' Calculated end address
    destEndLSB  := temp&$ff                        ' Destination end address LSB 
    destEndMSB  := temp>>8                         ' Destination end address MSB
    bytefill( @filename, $20, 16 )
    bytemove( @filename, fname, strsize(fname) )
    fileLength  := fLength                         ' File length
     
    Success := kernel.start( @parameter1 )
      
PUB init (  sPin, mPin ) | i

    repeat i from 0 to buffSize
      buffer[i]:= 8
    timer := 0
    
    parameter1  := @buffer[0]
    parameter2  := buffSize
    parameter3  := @bufferPointer
    parameter4  := 1<<mPin
    parameter5  := sPin
         
    midBufferPointer := @buffer[buffSize/2]
    
    return buffSize
PUB clearBuffer | i

    repeat i from 0 to buffSize
      buffer[i]:= 8
         
PUB checkForBufferUpdate : returnCurrentBuffer | i, bufferUpdate

    bufferUpdate := false
    timer := 0
    getDeltaTime
        
    repeat while bufferUpdate == false and (ina&parameter4) > 0 and (timer =< timeOut)

      if currentBuffer <> 2 and bufferPointer => midBufferPointer
        currentBuffer := 2
        bufferUpdate := true
        returnCurrentBuffer := @buffer[0]

      if currentBuffer <> 1 and bufferPointer < midBufferPointer
        currentBuffer := 1
        bufferUpdate := true
        returnCurrentBuffer := @buffer[buffSize/2]

      timer := timer + 1
               
    if bufferUpdate == false and (ina&parameter4) > 0
      returnCurrentBuffer := -1
    elseif bufferUpdate == false 
      returnCurrentBuffer := 0
              
PUB getCurrentBufferPos
    return bufferPointer

PRI getDeltaTime | temp
    temp := cnt - refTime
    refTime := cnt
    return temp
    